CON
  _clkmode = xinput
  _xinfreq = $4E495053 ' SPIN

  'XMODEM chars from ymodem.txt
  SOH=$01
  STX=$02
  EOT=$04
  ACK=$06
  NAK=$15
  CAN=$18
  Cee=$43  'liberties here
  Zee=$1A  'or SUB  (DOS EOF?)

  MSG_TIMEOUT  = -2
  MSG_EOT      = -3
  BYTE_TIMEOUT = -4
  MSG_BADNUM   = -5
  MSG_CRCERR   = -6

OBJ  'Objects Section
  mem : "cmalloc"
  ser : "cserial"
  c : "cfileio_os"

dat
  pdata long 0
  long 0[1000]

PUB SendFile(argc, argv) | infile, filesize, val, len, fname, packetnum, str
  if (argc <> 2)
    ser.dbprintf0(string("usage: sb file\n"))
    return
  pdata := mem.malloc(1028)
  ifnot pdata
    ser.dbprintf0(string("Could not malloc 1028 bytes for the data buffer\n"))
    return
  fname := long[argv][1]
  infile := c.fopen(fname, string("r"))
  ifnot infile
    ser.dbprintf1(string("Could not open %s\n"), fname)
    mem.free(pdata)
    return
  filesize := c.getfilesize(infile)
  bytefill(pdata, 0, 130)
  byte[pdata][1] := 255
  str := pdata + 2
  len := strsize(fname) + 1
  bytemove(str, fname, len)
  str += len
  itoa10(filesize, str)
  {
  c.sprintf2(pdata+2, string("%s %d"), fname, filesize)
  len := strsize(fname)
  byte[pdata][len+2] := 0
  }
  repeat
    val := ser.rxtime(30000)
    if val == -1 or val == 27
      c.fclose(infile)
      mem.free(pdata)
      return
    if val == CEE
      quit

  SendPacket(0, pdata, 128)
      
  repeat
    val := ser.rxtime(10000)
    if val == -1 or val == 27
      c.fclose(infile)
      mem.free(pdata)
      return
    if val == CEE
      quit

  packetnum := 1
  repeat while filesize > 0
    len := filesize
    if len > 1024
      len := 1024
    filesize -= len
    c.fread(pdata + 2, 1, len, infile)
    SendPacket(packetnum, pdata, len)
    packetnum++

  SendEOT
  byte[pdata][2] := 0
  SendPacket(0, pdata, 128)

  c.fclose(infile)
  mem.free(pdata)

PUB SendEOT | val
  repeat
    ser.tx(EOT)    
    repeat
      val := ser.rxtime(10000)
      if val == ACK
        return 1
      elseif val == NAK
        quit

PUB SendPacket(packetnum, ptr, num) | i, val, firstchar
  if (num =< 0) or (num > 1024)
    return
  elseif (num =< 128)
    num := 128
    firstchar := SOH
  else
    num := 1024
    firstchar := STX
  byte[ptr] := packetnum
  byte[ptr][1] := 255 - packetnum
  AppendCRC(ptr+2, num)
  repeat
    ser.tx(firstchar)
    repeat i from 0 to num + 3
      ser.tx(byte[ptr][i])
    repeat
      val := ser.rxtime(10000)
      if val == ACK
        return num
      elseif val == NAK
        quit
  return num

PUB AppendCRC(ptr, num) | crc
  crc := ComputeCRC(ptr, num)
  byte[ptr][num] := crc >> 8
  byte[ptr][num+1] := crc & $ff

PUB ComputeCRC(ptr, num)
  repeat num
    result ^= (byte[ptr++] << 8)
    repeat 8
      result <<= 1
      if result & $10000
        result ^= $1021
  result &= $ffff

PRI itoa10(number, str) | divisor, temp
{{
  This private routine is used to convert a signed integer contained in
  "number" to a decimal character string.  It is called by itoa when the
  numeric base parameter has a value of 10.
}}
  if (number == 0)
    byte[str++] := "0"
    byte[str] := 0
    return 1
  divisor := 1_000_000_000
  repeat while (divisor > number)
    divisor /= 10
  repeat while (divisor > 0)
    temp := number / divisor
    byte[str++] := temp + "0"
    number -= temp * divisor
    divisor /= 10
  byte[str++] := 0
