CON
  _clkmode = xinput
  _clkfreq = $4E495053 ' SPIN

  NEW_LINE = 10
  eeprom_pin = 28
  sdcard_pin = 16

OBJ
  c : "clib_os"
  rendez : "rendezvous"

DAT
  badflag long 0
  buffer byte 0[100]
  version byte "\nspinix 0.21\n", 0
  argv long 0[20]
  strbuf byte 0[50]
  strptr long 0
  aliasptr word 0[8]
  aliasnum long 0
  runmode long 0

DAT
  redirectin long 0
  redirectout long 0
  scriptfile long 0
  CouldNotOpen byte "Could not open %s\n", 0
  RedirectionError byte "Redirection error\n", 0

PUB main(argc, i) | pathstr[20]
  if argc > 1
    c.printf0(@version)

  strptr := @strbuf

  scriptfile := c.fopen(string("startup"), string("r"))

  REPEAT
    ' Close redirection files if opened
    if redirectin
      c.resetstdin
      c.fclose(redirectin)
      redirectin := 0
    if redirectout
      c.resetstdout
      c.fclose(redirectout)
      redirectout := 0

    if scriptfile
      if c.fgets(@buffer, 100, scriptfile) =< 0
        c.fclose(scriptfile)
        scriptfile := 0
        next
      i := strsize(@buffer) - 1
      if i => 0 AND byte[@buffer][i] == 10
        byte[@buffer][i] := 0

    else
      c.printf0(STRING("\n$"))
      c.gets(@buffer)

    if byte[@buffer] == "#"
      next

    CheckAlias
    argc := tokenize(@buffer, @argv)
    argc := Redirection(argc)

    ifnot argc
      next

    if strcomp(argv[0], string("alias"))
      AliasCommand(argc)
      next

    if strcomp(argv[0], string("set"))
      SetCommand(argc)
      next

    ifnot (i := FindExecTarget(argv[0], @pathstr))
      next

    if i == 1
      if scriptfile
        c.fclose(scriptfile)
      scriptfile := c.fopen(@pathstr, string("r"))
      ifnot scriptfile
        c.printf1(@CouldNotOpen, @pathstr)
    elseif i := run(@pathstr, argc, @argv, runmode)
      if i == -2
        c.printf1(string("Not enough memory to run %s\n"), @pathstr)
      else
        c.printf1(@CouldNotOpen, @pathstr)

PUB AliasCommand(argc)
  if argc == 2
    c.strcpy(strptr, argv[1])
    aliasptr[aliasnum++] := strptr
    strptr += strsize(strptr) + 1

PUB SetCommand(argc) | i
  if aliasnum
    repeat i from 0 to aliasnum-1
      c.printf1(string("alias %s\n"), aliasptr[i])

PUB CheckAlias | i, ptr, len1, len2, len3
  ifnot aliasnum
    return

  ptr := FindChar(@buffer, " ")
  if byte[ptr]
    len1 := strsize(ptr+1)
    byte[ptr] := 0
  else
    len1 := 0
  len2 := strsize(@buffer)

  repeat i from 0 to aliasnum-1
    ptr := FindChar(aliasptr[i], "=")
    if byte[ptr]
      byte[ptr] := 0
      if strcomp(aliasptr[i], @buffer)
        len3 := strsize(ptr+1)
        if len1 AND len2 <> len3
          bytemove(@buffer+len3+1, @buffer+len2+1, len1+1)
        bytemove(@buffer, ptr+1, len3+1)
        if len1
          byte[@buffer+len3] := " "
        byte[ptr] := "="
        'c.printf1(string("%s\n"), @buffer)
        return
      byte[ptr] := "="

  if len1
    byte[@buffer+len2] := " "

PUB FindExecTarget(fname, pathstr) | temp, infile, typestr[2]
  c.strcpy(pathstr, fname)
  repeat 2
    if (infile := c.fopen(pathstr, string("r")))
      quit
    temp := FindChar(pathstr, "/")
    if byte[temp]
      quit
    c.strcpy(pathstr, string("/bin/"))
    c.strcat(pathstr, fname)

  ifnot infile
    c.printf1(@CouldNotOpen, fname)
    return

  typestr[1] := typestr[0] := 0
  c.fread(@typestr, 1, 4, infile)
  c.fclose(infile)

  if strcomp(@typestr, string("SPIN"))
    result := 2
  elseif strcomp(@typestr, string("#she"))
    result := 1
  else
    c.printf1(string("%s is not a spin or script file\n"), fname)

PUB AddToCogTable(cognum, type, name, startaddr, size) | entryptr
  entryptr := rendez#cogtable + (cognum * 24)
  byte[entryptr] := type
  bytemove(entryptr+1, name, 19)
  byte[entryptr+19] := 0
  word[entryptr+20] := startaddr
  word[entryptr+22] := size

PUB RemoveFromCogTable(cognum) | entryptr
  entryptr := rendez#cogtable + (cognum * 24)
  byte[entryptr] := 0

PUB Redirection(argc) | i, argc1, ptr, char, mode
  runmode := 0
  if (argc < 2)
    return argc
  argc1 := 1
  repeat i from 1 to argc - 1
    ptr := argv[i]
    char := byte[ptr++]
    if char == "<"
      if (byte[ptr] == 0)
        ptr := argv[++i]
        if (i => argc)
          c.printf0(@RedirectionError)
          argc1 := 0
          quit
      redirectin := c.fopen(ptr, string("r"))
      ifnot redirectin
        c.printf1(@CouldNotOpen, ptr)
        argc1 := 0
        quit
      else
        c.setstdin(redirectin)
    elseif char == ">"
      if (byte[ptr] == ">")
        ptr++
        mode := string("a")
      else
        mode := string("w")
      if (byte[ptr] == 0)
        ptr := argv[++i]
        if (i => argc)
          c.printf0(@RedirectionError)
          argc1 := 0
          quit
      redirectout := c.fopen(ptr, mode)
      ifnot redirectout
        c.printf1(@CouldNotOpen, ptr)
        argc1 := 0
        quit
      else
        c.setstdout(redirectout)
    elseif char == "&"
      if byte[ptr] == "&"
        runmode := cogid + 1
      else
        runmode := -1
    else
      argv[argc1++] := argv[i]
  return argc1

' This routine returns a pointer to the first character not
' matching the passed value
PUB SkipChar(str, value_0)
  REPEAT WHILE (BYTE[str])
    IF (BYTE[str] <> value_0)
      QUIT
    str++
  RETURN str
  
' This routine returns a pointer to the first charcter that
' matches the passed value
PUB FindChar(str, value_0)
  REPEAT WHILE (BYTE[str])
    IF (BYTE[str] == value_0)
      QUIT
    str++
  RETURN str
  
' This routine extracts tokens from the input string that
' are seperated by at least one space character
PUB tokenize(ptr, tokens) | num
  num := 0
  repeat
    ptr := SkipChar(ptr, " ")
    ifnot byte[ptr]
      quit
    num++
    if byte[ptr] == $22
      long[tokens] := ++ptr
      ptr := FindChar(ptr, $22)
    else
      long[tokens] := ptr
      ptr := FindChar(ptr, " ")
    tokens += 4
    IF (BYTE[ptr] == 0)
      QUIT
    BYTE[ptr++] := 0
  RETURN num

PUB run(fname, argc, pargv, mode) | cognum, entryptr
  long[pargv] := fname
  cognum := c.run(argc, pargv, mode)
  if cognum < 0
    return cognum
  entryptr := rendez#cogtable + (cognum * 24)
  ifnot mode
    repeat while byte[entryptr]
    
